<?php

declare(strict_types=1);

namespace App\Repository;

final class TblOfertaFavoritaUsuarioRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblOfertaFavoritaUsuarioId): object
    {
        $query = 'SELECT * FROM `TblOfertaFavoritaUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblOfertaFavoritaUsuarioId);
        $statement->execute();
        $TblOfertaFavoritaUsuario = $statement->fetchObject();
        if (! $TblOfertaFavoritaUsuario) {
            throw new \Exception('TblOfertaFavoritaUsuario not found.', 404);
        }

        return $TblOfertaFavoritaUsuario;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblOfertaFavoritaUsuario` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblOfertaFavoritaUsuario): object
    {
        $query = 'INSERT INTO `TblOfertaFavoritaUsuario` (`IdUsuario`, `IdOferta`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:IdUsuario, :IdOferta, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblOfertaFavoritaUsuario->id);
//         $statement->bindParam('fecha', $TblOfertaFavoritaUsuario->fecha);
        $statement->bindParam('IdUsuario', $TblOfertaFavoritaUsuario->IdUsuario);
        $statement->bindParam('IdOferta', $TblOfertaFavoritaUsuario->IdOferta);
        $statement->bindParam('field1', $TblOfertaFavoritaUsuario->field1);
        $statement->bindParam('field2', $TblOfertaFavoritaUsuario->field2);
        $statement->bindParam('field3', $TblOfertaFavoritaUsuario->field3);
        $statement->bindParam('field4', $TblOfertaFavoritaUsuario->field4);
        $statement->bindParam('field5', $TblOfertaFavoritaUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblOfertaFavoritaUsuario, object $data): object
    {
        if (isset($data->fecha)) {
            $TblOfertaFavoritaUsuario->fecha = $data->fecha;
        }
        if (isset($data->IdUsuario)) {
            $TblOfertaFavoritaUsuario->IdUsuario = $data->IdUsuario;
        }
        if (isset($data->IdOferta)) {
            $TblOfertaFavoritaUsuario->IdOferta = $data->IdOferta;
        }
        if (isset($data->field1)) {
            $TblOfertaFavoritaUsuario->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblOfertaFavoritaUsuario->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblOfertaFavoritaUsuario->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblOfertaFavoritaUsuario->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblOfertaFavoritaUsuario->field5 = $data->field5;
        }

        $query = 'UPDATE `TblOfertaFavoritaUsuario` SET `fecha` = :fecha, `IdUsuario` = :IdUsuario, `IdOferta` = :IdOferta, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblOfertaFavoritaUsuario->id);
        $statement->bindParam('fecha', $TblOfertaFavoritaUsuario->fecha);
        $statement->bindParam('IdUsuario', $TblOfertaFavoritaUsuario->IdUsuario);
        $statement->bindParam('IdOferta', $TblOfertaFavoritaUsuario->IdOferta);
        $statement->bindParam('field1', $TblOfertaFavoritaUsuario->field1);
        $statement->bindParam('field2', $TblOfertaFavoritaUsuario->field2);
        $statement->bindParam('field3', $TblOfertaFavoritaUsuario->field3);
        $statement->bindParam('field4', $TblOfertaFavoritaUsuario->field4);
        $statement->bindParam('field5', $TblOfertaFavoritaUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblOfertaFavoritaUsuario->id);
    }

    public function delete(int $TblOfertaFavoritaUsuarioId): void
    {
        $query = 'DELETE FROM `TblOfertaFavoritaUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblOfertaFavoritaUsuarioId);
        $statement->execute();
    }
}
